
public class ParseTree
{
	public static void main( String args[] )
	{
		ArrayBinaryTree bt = new ArrayBinaryTree();
		// parse tree that represents 3*5 + (6-3)
		int root = bt.addRoot( "+" );
		int times = bt.insertLeft( root, "*" );
		int minus = bt.insertRight( root, "-" );
		bt.insertLeft( times, "3" );
		bt.insertRight( times, "5" );
		bt.insertLeft( minus, "6" );
		int x = bt.insertRight( minus, "3" );
		System.out.println( "Number of nodes in tree: " + bt.size() );
		System.out.println( "Equation: " );
		printEquation( bt, root );
		System.out.println();
			
		// test other tree methods
		System.out.println( bt.isInternal( times ) );
		System.out.println( bt.isInternal( x ) );
		System.out.println( bt.isExternal( x ) );
		System.out.println( bt.getElement( x ) );
		System.out.println( bt.getElement( bt.sibling( x ) ));
		System.out.println( bt.getElement( bt.parent( x ) ));
		System.out.println( bt.replace( x, "88" ) );
		printEquation( bt, root );
		System.out.println();
		System.out.println( bt.remove( x ) );
		printEquation( bt, root );
		System.out.println();

	}
	
	// inorder traversal of a binary tree
	public static void printEquation( ArrayBinaryTree t, int v )
	{
		if ( t.hasLeft( v ) )
			printEquation( t, t.left( v ) );
		System.out.print( " " +  t.getElement( v ) +  " " );
		if ( t.hasRight( v ) )
			printEquation( t, t.right( v ) );
	}
}